---
八大排序
---

#### 前言

八大排序：

1. 冒泡排序
2. 插入排序
3. 选择排序
4. 快速排序
5. 堆排序

#### 冒泡排序

```java
    private static void sort(int[] data) {
        //排序
        for (int i = 0; i < data.length - 1; i++) {
            boolean isSorted = true;
            for (int j = 0; j < data.length-1-i; j++) {
                if (data[j+1] < data[j]) {
                    int temp = data[j+1];
                    data[j+1] = data[j];
                    data[j] = temp;
                    isSorted = false;
                }
            }
            if (isSorted) break;
        }
        //输出
        System.out.println(Arrays.toString(data));
    }
```

#### 插入排序

```java
    private static void sort(int[] data) {
        //排序
        for (int i = 1; i < data.length; i++) {
            for (int j = i; (j > 0) && (data[j - 1] > data[j]); j--) {
                int temp = data[j];
                data[j] = data[j - 1];
                data[j - 1] = temp;
            }
        }
        //输出
        System.out.println(Arrays.toString(data));
    }
```

#### 选择排序

```java
    private static void sort(int[] data) {
        //排序
        for (int i = 0; i < data.length - 1; i++) {
            for (int j = i + 1; j < data.length; j++) {
                if (data[i] > data[j]) {
                    int temp = data[i];
                    data[i] = data[j];
                    data[j] = temp;
                }
            }
        }
        //输出
        System.out.println(Arrays.toString(data));
    }
```

#### 快速排序

```java
public class QuickSort {
    public static void main(String[] args) {
        int[] data = new int[]{1, 4, 0, 4, 7, 2, 9, 8};
        //排序
        sort(data, 0, data.length - 1);
        //输出
        System.out.println(Arrays.toString(data));
    }

    private static void sort(int[] data, int left, int right) {
        //左下标一定小于又下标，否则就越界了
        if (left < right) {
            //对数组进行分割，取出下次分割的基准标号
            int base = division(data, left, right);
            //对基准标号左侧的一组数组进行递归的切割，以至于将这些数值完整的排序
            sort(data, left, base - 1);
            //对基准标号右侧的一组数值进行递归的切割，以至于将这些数值
            sort(data, base + 1, right);
        }
    }

    private static int division(int[] list, int left, int right) {
        //以左边的数为基本值
        int base = list[left];
        while (left < right) {
            //从序列右端开始，往左遍历，直到找到小于 base 的值
            while (left < right && list[right] >= base) {
                right--;
            }
            //找到比 base 小的元素，将这个元素放在最左边的位置
            list[left] = list[right];

            //从序列左端开始，往右遍历，直到找到大于 base 的值
            while (left < right && list[left] <= base) {
                left++;
            }
            //找到比 base 大的元素，将这个元素放在最右边的位置
            list[right] = list[left];
        }
        //最后将base放到left位置，此时，left位置的左侧数值都应该比left小;
        //而left位置的右侧数值都应该比left大
        list[left] = base;
        return left;
    }
}
```

#### 堆排序

